// Copyright (c) 2024 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// t_func-import_test.go
package expr

import (
	"testing"
)

func TestFuncImport(t *testing.T) {
	section := "Func-Import"
	inputs := []inputType{
		/*   1 */ {`builtin "import"; import("./test-funcs.expr"); (double(3+a) + 1) * two()`, int64(34), nil},
		/*   2 */ {`builtin "import"; import("test-funcs.expr"); (double(3+a) + 1) * two()`, int64(34), nil},
		/*   3 */ {`builtin "import"; importAll("./test-funcs.expr"); six()`, int64(6), nil},
		/*   4 */ {`builtin "import"; import("./sample-export-all.expr"); six()`, int64(6), nil},
	}

	t.Setenv("EXPR_PATH", ".")

	// parserTestSpec(t, section, inputs, 69)
	parserTest(t, section, inputs)
}
